Index: /trunk/anuga_work/development/gareth/experimental/balanced_dev/swb2_domain.py
===================================================================
--- /trunk/anuga_work/development/gareth/experimental/balanced_dev/swb2_domain.py	(revision 8396)
+++ /trunk/anuga_work/development/gareth/experimental/balanced_dev/swb2_domain.py	(revision 8397)
@@ -106,20 +106,37 @@
         print '##########################################################################'
         print '#'
-        print '# Using shallow_water_balanced2 solver in experimental/balanced_dev/'
-        print "#"
-        print "# This solver is experimental - it may cause your computer to explode "
-        print "#"
-        print "# It is not expected to perform well in problems with very"
+        print '# Using shallow_water_balanced2 solver in anuga_work/development/gareth/experimental/balanced_dev/'
+        print "#"
+        print "# This solver is experimental. Here are some tips on using it"
+        print "#"
+        print "# 1) When plotting outputs, I strongly suggest you examine centroid values, not vertex values"
+        print "# , as the latter can be completely misleading near strong gradients in the flow. "
+        print "# There is a util.py script in anuga_work/development/gareth/tests which might help you extract"
+        print "# quantities at centroid values from sww files."
+        print "# Note that to accuractely compute centroid values from sww files, the files need to store "
+        print "# vertices uniquely. This makes for large sww files (3x), but is the price to pay for the right answer"
+        print "# (unless we alter IO to allow centroids to be written to sww files, which would then affect"
+        print "# ANUGA viewer as well -- I expect this would be lots of work)"
+        print "#"
+        print "# 2) In field scale applications (where the depth is typically > 1m), I suggest you set"
+        print "# domain.minimum_allowed_height=0.01 (the default is 1.0e-3). With this setting, velocity"
+        print "# seems to be very well behaved"
+        print "#"
+        print "# 3) This solver is not expected to perform well in problems with very"
         print "# shallow water flowing down steep slopes (such that the stage_centroid_value "
-        print "# is less than the maximum bed_edge_value on a given triangle) "
-        print "#"
-        print "# Also, it allows the stage_centroid_value to drop to the minimum bed_edge_value"
+        print "# is less than the maximum bed_edge_value on a given triangle). However, analytical tests"
+        print "# suggest it can do typical wetting/drying situations very well (parabolic oscillations test case) "
+        print "#"
+        print "# 4) This solver allows the stage_centroid_value to drop to the minimum bed_edge_value"
         print "# on it's triangle. In other ANUGA versions (e.g. 1.2.1), the limit would be the"
         print "# bed_centroid_value. This means that triangles store slightly more water than they are"
         print "# typically interpreted to store, which might have significance in some applications."
         print "#"
-        print "# You will probably be able to tell if the above are causing you problems by convergence testing"
-        print "#"
-        print '# Note that many options in config.py have been overridden by the solver'
+        print "# You will probably be able to tell this is causing you problems by convergence testing"
+        print "#"
+        print '# 5) Note that many options in config.py have been overridden by the solver -- I have '
+        print '# deliberately attempted to get the solver to perform well with consistent values of '
+        print '# these parameters -- so I would advise against changing them unless you at least check that '
+        print '# it really does improve things'
         print '#'
         print '##########################################################################'
Index: /trunk/anuga_work/development/gareth/experimental/balanced_dev/swb2_domain_ext.c
===================================================================
--- /trunk/anuga_work/development/gareth/experimental/balanced_dev/swb2_domain_ext.c	(revision 8396)
+++ /trunk/anuga_work/development/gareth/experimental/balanced_dev/swb2_domain_ext.c	(revision 8397)
@@ -603,5 +603,5 @@
 
 
-  // Protect against initesimal and negative heights  
+  // Protect against inifintesimal and negative heights  
   if (maximum_allowed_speed < epsilon) {
     for (k=0; k<N; k++) {
@@ -630,5 +630,5 @@
   } else {
    
-    // Protect against initesimal and negative heights
+    // Protect against infinitesimal and negative heights
     for (k=0; k<N; k++) {
       hc = wc[k] - zc[k];