Index: /trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/generic_domain.py
===================================================================
--- /trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/generic_domain.py	(revision 8419)
+++ /trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/generic_domain.py	(revision 8420)
@@ -479,5 +479,7 @@
         if cfl > 2.0:
             self.CFL = cfl
-            log.warn('Setting CFL > 2.0')
+            msg = 'Setting CFL > 2.0'
+            #warnings.warn(msg)
+            log.warn()
 
         assert cfl > 0.0
Index: /trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/test_domain.py
===================================================================
--- /trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/test_domain.py	(revision 8419)
+++ /trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/test_domain.py	(revision 8420)
@@ -88,12 +88,12 @@
         
         try:
-            domain.set_CFL(2.0)
+            domain.set_CFL(3.0)
         except:
             pass
         else:
-            msg = 'Should have warned of cfl>1.0'
+            msg = 'Should have warned of cfl>2.0'
             raise Exception, msg
 
-        assert domain.CFL == 2.0
+        assert domain.CFL == 3.0
         
 
Index: /trunk/anuga_core/source/anuga/operators/mannings_operator.py
===================================================================
--- /trunk/anuga_core/source/anuga/operators/mannings_operator.py	(revision 8419)
+++ /trunk/anuga_core/source/anuga/operators/mannings_operator.py	(revision 8420)
@@ -63,5 +63,5 @@
 
 
-    def __parallel_safe(self):
+    def parallel_safe(self):
         """
         This operator only works with centroid values of quantities
Index: /trunk/anuga_core/source/anuga/operators/rate_operators.py
===================================================================
--- /trunk/anuga_core/source/anuga/operators/rate_operators.py	(revision 8419)
+++ /trunk/anuga_core/source/anuga/operators/rate_operators.py	(revision 8420)
@@ -154,5 +154,5 @@
         return rate
 
-    def __parallel_safe(self):
+    def parallel_safe(self):
         """Operator is applied independently on each cell and
         so is parallel safe.
Index: /trunk/anuga_core/source/anuga/shallow_water/forcing.py
===================================================================
--- /trunk/anuga_core/source/anuga/shallow_water/forcing.py	(revision 8419)
+++ /trunk/anuga_core/source/anuga/shallow_water/forcing.py	(revision 8420)
@@ -278,5 +278,5 @@
         if domain.numproc > 1:
             msg = 'Not implemented to run in parallel'
-            assert self.__parallel_safe(), msg
+            assert self.parallel_safe(), msg
 
         if center is None:
@@ -495,5 +495,5 @@
 
 
-    def __parallel_safe(self):
+    def parallel_safe(self):
         """
         These forcing terms only work on individual processors, the polygon
Index: /trunk/anuga_core/source/anuga_parallel/parallel_boyd_box_operator.py
===================================================================
--- /trunk/anuga_core/source/anuga_parallel/parallel_boyd_box_operator.py	(revision 8419)
+++ /trunk/anuga_core/source/anuga_parallel/parallel_boyd_box_operator.py	(revision 8420)
@@ -95,5 +95,5 @@
 
 
-    def __parallel_safe(self):
+    def parallel_safe(self):
 
         print "ZZZZ parallel_boyd"
Index: /trunk/anuga_core/source/anuga_parallel/parallel_inlet.py
===================================================================
--- /trunk/anuga_core/source/anuga_parallel/parallel_inlet.py	(revision 8419)
+++ /trunk/anuga_core/source/anuga_parallel/parallel_inlet.py	(revision 8420)
@@ -467,5 +467,5 @@
         return self.master_proc
 
-    def __parallel_safe(self):
+    def parallel_safe(self):
 
         return True
Index: /trunk/anuga_core/source/anuga_parallel/parallel_inlet_operator.py
===================================================================
--- /trunk/anuga_core/source/anuga_parallel/parallel_inlet_operator.py	(revision 8419)
+++ /trunk/anuga_core/source/anuga_parallel/parallel_inlet_operator.py	(revision 8420)
@@ -215,4 +215,4 @@
         return self.master_proc
 
-    def __parallel_safe(self):
+    def parallel_safe(self):
         return True