Index: /trunk/anuga_core/source/anuga/operators/base_operator.py
===================================================================
--- /trunk/anuga_core/source/anuga/operators/base_operator.py	(revision 8435)
+++ /trunk/anuga_core/source/anuga/operators/base_operator.py	(revision 8436)
@@ -63,6 +63,4 @@
         """By default an operator is not parallel safe
         """
-
-        print "ZZZZ in --parallel_safe base_oprator"
         return False
 
Index: /trunk/anuga_core/source/anuga/utilities/sparse_ext.c
===================================================================
--- /trunk/anuga_core/source/anuga/utilities/sparse_ext.c	(revision 8435)
+++ /trunk/anuga_core/source/anuga/utilities/sparse_ext.c	(revision 8436)
@@ -79,5 +79,5 @@
 
   
-  int dimensions[1], M, err, columns, rows;
+  int dimensions[2], M, err, columns, rows;
   
   // Convert Python arguments to C  
Index: /trunk/anuga_core/validation_tests/Tests/Analytical/deep_wave/produce_results.py
===================================================================
--- /trunk/anuga_core/validation_tests/Tests/Analytical/deep_wave/produce_results.py	(revision 8436)
+++ /trunk/anuga_core/validation_tests/Tests/Analytical/deep_wave/produce_results.py	(revision 8436)
@@ -0,0 +1,2 @@
+import run_wave
+import plotme
Index: unk/anuga_core/validation_tests/Tests/Analytical/deep_wave/run_problem.py
===================================================================
--- /trunk/anuga_core/validation_tests/Tests/Analytical/deep_wave/run_problem.py	(revision 8435)
+++ 	(revision )
@@ -1,2 +1,0 @@
-import run_wave
-import plotme
Index: /trunk/anuga_core/validation_tests/Tests/Analytical/deep_wave/run_wave.py
===================================================================
--- /trunk/anuga_core/validation_tests/Tests/Analytical/deep_wave/run_wave.py	(revision 8435)
+++ /trunk/anuga_core/validation_tests/Tests/Analytical/deep_wave/run_wave.py	(revision 8436)
@@ -39,5 +39,5 @@
 # Setup domain
 #------------------------------------------------------------------------------
-dx = 1000.
+dx = 500.
 dy = dx
 L = 100000.
@@ -55,4 +55,5 @@
 # Setup Algorithm
 #------------------------------------------------------------------------------
+#domain.set_flow_algorithm(2.0)
 #domain.set_timestepping_method('rk2')
 #domain.set_default_order(2)
@@ -100,5 +101,8 @@
 Bw2 = anuga.shallow_water.boundaries.Transmissive_n_momentum_zero_t_momentum_set_stage_boundary(domain, waveform)
 #Bw3 = swb2_boundary_conditions.Transmissive_momentum_nudge_stage_boundary(domain, waveform)
-                    
+
+def zero_fun(t):
+    return 0.0                    
+Bw0 = anuga.shallow_water.boundaries.Transmissive_n_momentum_zero_t_momentum_set_stage_boundary(domain, zero_fun)
 
 
Index: /trunk/anuga_core/validation_tests/Tests/Analytical/steep_slope/channel_SU_2plot.py
===================================================================
--- /trunk/anuga_core/validation_tests/Tests/Analytical/steep_slope/channel_SU_2plot.py	(revision 8435)
+++ /trunk/anuga_core/validation_tests/Tests/Analytical/steep_slope/channel_SU_2plot.py	(revision 8436)
@@ -95,4 +95,5 @@
 pyplot.plot(p2.y[v],p2.xvel[100,v], 'o', label='Numerical')
 pyplot.plot((0,100),(uana,uana),label='Analytical')
+pyplot.ylim([1.0,3.0])
 pyplot.xlabel('Distance along the line x==50 (across the slope) (m)')
 pyplot.ylabel('Velocity m/s')
Index: /trunk/anuga_core/validation_tests/Tests/Analytical/steep_slope/channel_SU_sparse.py
===================================================================
--- /trunk/anuga_core/validation_tests/Tests/Analytical/steep_slope/channel_SU_sparse.py	(revision 8435)
+++ /trunk/anuga_core/validation_tests/Tests/Analytical/steep_slope/channel_SU_sparse.py	(revision 8436)
@@ -3,14 +3,4 @@
 """
 import sys
-
-#---------------
-# I am having trouble with my environmental variables -- this is a 
-# quick fix -- PYTHONPATH should have this value
-#---------------
-#sys.path[0]='/nas/gemd/georisk_models/inundation/sandpits/gdavies/trunk/anuga_core/source'
-
-#--------------
-# Then from here, write the script as usual
-#--------------
 
 #------------------------------------------------------------------------------
@@ -33,5 +23,7 @@
 domain.set_name('channel_SU_2_v2') # Output name
 domain.set_store_vertices_uniquely(True)
-domain.CFL=1.0
+domain.set_flow_algorithm(2.0)
+#domain.CFL=1.0
+#domain.set_sloped_mannings_function()
 #------------------------------------------------------------------------------
 # Setup initial conditions
@@ -45,7 +37,7 @@
     return stg#*(stg>topo) + topo*(stg<=topo)
 
-line1=[ [0.,0.], [0., 100.] ]
+line1=[ [1.,0.], [1., 100.] ]
 Qin=20.
-Inlet_operator(domain, line1,Qin)
+Inlet_operator(domain, line1, Qin)
 
 domain.set_quantity('elevation', topography) # Use function for elevation