Index: /trunk/anuga_work/development/Busselton/Analysis/export_results_max.py
===================================================================
--- /trunk/anuga_work/development/Busselton/Analysis/export_results_max.py	(revision 8451)
+++ /trunk/anuga_work/development/Busselton/Analysis/export_results_max.py	(revision 8452)
@@ -24,11 +24,12 @@
 rootDir = r"/short/w85/Shane/Output"
 scenario_name = "Busselton"
-event = "B4"
-#directory = join(rootDir,event)
+event = "B2Full"
 
-time_dir1 = "final_"+event+"_sfm547_np1"
-time_dir2 = "final_"+event+"_sfm547_np1_From21600"
-
-time_dirs = [time_dir1,time_dir2]  
+time_dirs = [#"final_"+event+"_sfm547_np1",\
+#             "final_"+event+"_sfm547_np1_From28800",\
+#             "final_"+event+"_sfm547_np1_From57600",\
+#             "final_"+event+"_sfm547_np1_From86400",\
+#             "final_"+event+"_sfm547_np1_From108000",\
+             "final_"+event+"_sfm547_np1_From115200"] 
 
 #Modify the cellsize value to set the size of the raster you require
@@ -66,69 +67,74 @@
 ######
 
-if myid == 0:
-    time_dir = time_dirs[0] 
-    var = vars[0]
+proc = 0
+Needed = True
+
+for dirID in range(len(time_dirs)):    
     
-elif myid == 1:
-    time_dir = time_dirs[1] 
-    var = vars[1]
+    if myid == proc:
+        time_dir = time_dirs[dirID] 
+        var = vars[0]
+        
+    elif myid == proc + 1:
+        time_dir = time_dirs[dirID] 
+        var = vars[1]
+        
+    proc+=2  
+
+if myid >= len(time_dirs)*2:
+    print "I am not needed: Proc ", myid
+    Needed = False
+
+if Needed:
+        
+    if var not in var_equations:
+        print 'Unrecognized variable name: %s' % which_var
+        sys.exit()
     
-elif myid == 2:
-    time_dir = time_dirs[0] 
-    var = vars[1]
+    for which_area in area:
+        if which_area == 'All':
+            easting_min = None
+            easting_max = None
+            northing_min = None
+            northing_max = None
+        else:
+            try:
+                easting_min = eval('project.xmin%s' % which_area)
+                easting_max = eval('project.xmax%s' % which_area)
+                northing_min = eval('project.ymin%s' % which_area)
+                northing_max = eval('project.ymax%s' % which_area)
+            except AttributeError:
+                print 'Unrecognized area name: %s' % which_area
+                break
     
-elif myid == 3:
-    time_dir = time_dirs[1] 
-    var = vars[0]
+        names = []
+        Name = glob.glob(join(rootDir,event,time_dir,scenario_name) +'*.sww')
+        names.append(Name)
     
-if var not in var_equations:
-    print 'Unrecognized variable name: %s' % which_var
-    sys.exit()
-
-for which_area in area:
-    if which_area == 'All':
-        easting_min = None
-        easting_max = None
-        northing_min = None
-        northing_max = None
-    else:
-        try:
-            easting_min = eval('project.xmin%s' % which_area)
-            easting_max = eval('project.xmax%s' % which_area)
-            northing_min = eval('project.ymin%s' % which_area)
-            northing_max = eval('project.ymax%s' % which_area)
-        except AttributeError:
-            print 'Unrecognized area name: %s' % which_area
-            break
-
-    names = []
-    Name = glob.glob(join(rootDir,event,time_dir,scenario_name) +'*.sww')
-    names.append(Name)
-
-    for names in names:
-        
-        asc_name = []   
-        print 'start sww2dem: time_dir = %s' % time_dir               
-        for name in names:
-
-            test = name
-            name = test[:-4]
-            outname = name + '_' + which_area + '_' + var + str(cellsize) + "m"
-            quantityname = var_equations[var]
-
-            print 'start sww2dem: name = %s' % os.path.basename(name)
-            print outname
-            anuga.sww2dem(name+'.sww', outname+'.asc',
-                        quantity = quantityname,
-                        cellsize = cellsize,      
-                        easting_min = easting_min,
-                        easting_max = easting_max,
-                        northing_min = northing_min,
-                        northing_max = northing_max,        
-                        reduction = timestep, 
-                        verbose = True)
-
-            asc_name.append(outname + '.asc')
+        for names in names:
             
+            asc_name = []   
+            print 'start sww2dem: time_dir = %s' % time_dir               
+            for name in names:
+    
+                test = name
+                name = test[:-4]
+                outname = name + '_' + which_area + '_' + var + str(cellsize) + "m"
+                quantityname = var_equations[var]
+    
+                print 'start sww2dem: name = %s' % os.path.basename(name)
+                print outname
+                anuga.sww2dem(name+'.sww', outname+'.asc',
+                            quantity = quantityname,
+                            cellsize = cellsize,      
+                            easting_min = easting_min,
+                            easting_max = easting_max,
+                            northing_min = northing_min,
+                            northing_max = northing_max,        
+                            reduction = timestep, 
+                            verbose = True)
+    
+                asc_name.append(outname + '.asc')
+                
 barrier()
 
Index: /trunk/anuga_work/development/Busselton/Analysis/master.py
===================================================================
--- /trunk/anuga_work/development/Busselton/Analysis/master.py	(revision 8451)
+++ /trunk/anuga_work/development/Busselton/Analysis/master.py	(revision 8452)
@@ -27,5 +27,5 @@
 wall[32] = "07:00:00"
 
-np = 4
+np = 16
 
 ScriptName = "/home/547/sfm547/Busselton/Analysis/export_results_max.py"
Index: /trunk/anuga_work/development/Busselton/B1Full/anuga.log
===================================================================
--- /trunk/anuga_work/development/Busselton/B1Full/anuga.log	(revision 8451)
+++ /trunk/anuga_work/development/Busselton/B1Full/anuga.log	(revision 8452)
@@ -1,8 +1,8 @@
-2012-06-16 18:13:52,079 INFO           anuga.utilities.log:0   |Logfile is './anuga.log' with logging level of INFO, console logging level is CRITICAL
-2012-06-16 18:13:52,210 INFO                       polygon:959 |--------------------------------------------------------------------------------
-2012-06-16 18:13:52,210 INFO                       polygon:960 |Polygon  Max triangle area (m^2)  Total area (km^2)  Estimated #triangles
-2012-06-16 18:13:52,211 INFO                       polygon:962 |--------------------------------------------------------------------------------
-2012-06-16 18:13:52,211 INFO                       polygon:976 |Interior 100                      56.48              564762
-2012-06-16 18:13:52,212 INFO                       polygon:984 |Bounding 10000                    352.99             35299
-2012-06-16 18:13:52,212 INFO                       polygon:989 |Estimated total number of triangles: 857230
-2012-06-16 18:13:52,212 INFO                       polygon:990 |Note: This is generally about 20% less than the final amount
+2012-06-18 16:19:21,783 INFO           anuga.utilities.log:0   |Logfile is './anuga.log' with logging level of INFO, console logging level is CRITICAL
+2012-06-18 16:19:21,816 INFO                       polygon:959 |--------------------------------------------------------------------------------
+2012-06-18 16:19:21,816 INFO                       polygon:960 |Polygon  Max triangle area (m^2)  Total area (km^2)  Estimated #triangles
+2012-06-18 16:19:21,816 INFO                       polygon:962 |--------------------------------------------------------------------------------
+2012-06-18 16:19:21,817 INFO                       polygon:976 |Interior 100                      56.48              564762
+2012-06-18 16:19:21,817 INFO                       polygon:984 |Bounding 10000                    352.99             35299
+2012-06-18 16:19:21,818 INFO                       polygon:989 |Estimated total number of triangles: 857230
+2012-06-18 16:19:21,818 INFO                       polygon:990 |Note: This is generally about 20% less than the final amount
Index: /trunk/anuga_work/development/Busselton/B2Full/anuga.log
===================================================================
--- /trunk/anuga_work/development/Busselton/B2Full/anuga.log	(revision 8451)
+++ /trunk/anuga_work/development/Busselton/B2Full/anuga.log	(revision 8452)
@@ -1,8 +1,8 @@
-2012-06-15 15:13:55,701 INFO           anuga.utilities.log:0   |Logfile is './anuga.log' with logging level of INFO, console logging level is CRITICAL
-2012-06-15 15:13:55,798 INFO                       polygon:959 |--------------------------------------------------------------------------------
-2012-06-15 15:13:55,798 INFO                       polygon:960 |Polygon  Max triangle area (m^2)  Total area (km^2)  Estimated #triangles
-2012-06-15 15:13:55,798 INFO                       polygon:962 |--------------------------------------------------------------------------------
-2012-06-15 15:13:55,802 INFO                       polygon:976 |Interior 100                      56.48              564762
-2012-06-15 15:13:55,802 INFO                       polygon:984 |Bounding 10000                    352.99             35299
-2012-06-15 15:13:55,802 INFO                       polygon:989 |Estimated total number of triangles: 857230
-2012-06-15 15:13:55,802 INFO                       polygon:990 |Note: This is generally about 20% less than the final amount
+2012-06-18 16:31:17,239 INFO           anuga.utilities.log:0   |Logfile is './anuga.log' with logging level of INFO, console logging level is CRITICAL
+2012-06-18 16:31:17,265 INFO                       polygon:959 |--------------------------------------------------------------------------------
+2012-06-18 16:31:17,265 INFO                       polygon:960 |Polygon  Max triangle area (m^2)  Total area (km^2)  Estimated #triangles
+2012-06-18 16:31:17,265 INFO                       polygon:962 |--------------------------------------------------------------------------------
+2012-06-18 16:31:17,266 INFO                       polygon:976 |Interior 100                      56.48              564762
+2012-06-18 16:31:17,266 INFO                       polygon:984 |Bounding 10000                    352.99             35299
+2012-06-18 16:31:17,266 INFO                       polygon:989 |Estimated total number of triangles: 857230
+2012-06-18 16:31:17,266 INFO                       polygon:990 |Note: This is generally about 20% less than the final amount
Index: /trunk/anuga_work/development/Busselton/B3Full/anuga.log
===================================================================
--- /trunk/anuga_work/development/Busselton/B3Full/anuga.log	(revision 8451)
+++ /trunk/anuga_work/development/Busselton/B3Full/anuga.log	(revision 8452)
@@ -1,8 +1,8 @@
-2012-06-13 09:57:27,185 INFO           anuga.utilities.log:0   |Logfile is './anuga.log' with logging level of INFO, console logging level is CRITICAL
-2012-06-13 09:57:27,296 INFO                       polygon:959 |--------------------------------------------------------------------------------
-2012-06-13 09:57:27,297 INFO                       polygon:960 |Polygon  Max triangle area (m^2)  Total area (km^2)  Estimated #triangles
-2012-06-13 09:57:27,297 INFO                       polygon:962 |--------------------------------------------------------------------------------
-2012-06-13 09:57:27,298 INFO                       polygon:976 |Interior 100                      56.48              564762
-2012-06-13 09:57:27,298 INFO                       polygon:984 |Bounding 10000                    352.99             35299
-2012-06-13 09:57:27,298 INFO                       polygon:989 |Estimated total number of triangles: 857230
-2012-06-13 09:57:27,299 INFO                       polygon:990 |Note: This is generally about 20% less than the final amount
+2012-06-18 16:31:17,284 INFO           anuga.utilities.log:0   |Logfile is './anuga.log' with logging level of INFO, console logging level is CRITICAL
+2012-06-18 16:31:17,306 INFO                       polygon:959 |--------------------------------------------------------------------------------
+2012-06-18 16:31:17,306 INFO                       polygon:960 |Polygon  Max triangle area (m^2)  Total area (km^2)  Estimated #triangles
+2012-06-18 16:31:17,306 INFO                       polygon:962 |--------------------------------------------------------------------------------
+2012-06-18 16:31:17,307 INFO                       polygon:976 |Interior 100                      56.48              564762
+2012-06-18 16:31:17,307 INFO                       polygon:984 |Bounding 10000                    352.99             35299
+2012-06-18 16:31:17,307 INFO                       polygon:989 |Estimated total number of triangles: 857230
+2012-06-18 16:31:17,307 INFO                       polygon:990 |Note: This is generally about 20% less than the final amount
Index: /trunk/anuga_work/development/Busselton/B4Full/anuga.log
===================================================================
--- /trunk/anuga_work/development/Busselton/B4Full/anuga.log	(revision 8451)
+++ /trunk/anuga_work/development/Busselton/B4Full/anuga.log	(revision 8452)
@@ -1,8 +1,8 @@
-2012-06-16 18:14:42,834 INFO           anuga.utilities.log:0   |Logfile is './anuga.log' with logging level of INFO, console logging level is CRITICAL
-2012-06-16 18:14:42,868 INFO                       polygon:959 |--------------------------------------------------------------------------------
-2012-06-16 18:14:42,868 INFO                       polygon:960 |Polygon  Max triangle area (m^2)  Total area (km^2)  Estimated #triangles
-2012-06-16 18:14:42,868 INFO                       polygon:962 |--------------------------------------------------------------------------------
-2012-06-16 18:14:42,869 INFO                       polygon:976 |Interior 100                      56.48              564762
-2012-06-16 18:14:42,870 INFO                       polygon:984 |Bounding 10000                    352.99             35299
-2012-06-16 18:14:42,870 INFO                       polygon:989 |Estimated total number of triangles: 857230
-2012-06-16 18:14:42,870 INFO                       polygon:990 |Note: This is generally about 20% less than the final amount
+2012-06-20 22:53:16,886 INFO           anuga.utilities.log:0   |Logfile is './anuga.log' with logging level of INFO, console logging level is CRITICAL
+2012-06-20 22:53:16,952 INFO                       polygon:959 |--------------------------------------------------------------------------------
+2012-06-20 22:53:16,953 INFO                       polygon:960 |Polygon  Max triangle area (m^2)  Total area (km^2)  Estimated #triangles
+2012-06-20 22:53:16,953 INFO                       polygon:962 |--------------------------------------------------------------------------------
+2012-06-20 22:53:16,953 INFO                       polygon:976 |Interior 100                      56.48              564762
+2012-06-20 22:53:16,953 INFO                       polygon:984 |Bounding 10000                    352.99             35299
+2012-06-20 22:53:16,954 INFO                       polygon:989 |Estimated total number of triangles: 857230
+2012-06-20 22:53:16,954 INFO                       polygon:990 |Note: This is generally about 20% less than the final amount