Index: /trunk/anuga_core/source/anuga_parallel/distribute_mesh.py
===================================================================
--- /trunk/anuga_core/source/anuga_parallel/distribute_mesh.py	(revision 8495)
+++ /trunk/anuga_core/source/anuga_parallel/distribute_mesh.py	(revision 8496)
@@ -26,4 +26,6 @@
 
 from anuga.abstract_2d_finite_volumes.neighbour_mesh import Mesh
+from anuga import indent
+
 
 #########################################################
@@ -1149,5 +1151,5 @@
     submesh_cell = {}
     
-    if verbose: print 'process %d receiving submesh from process %d' %(myid, p)
+    if verbose: print indent+'P%d: Receiving submesh from P%d' %(myid, p)
 
     # receive the tagmap for the boundary conditions
Index: /trunk/anuga_core/source/anuga_parallel/parallel_api.py
===================================================================
--- /trunk/anuga_core/source/anuga_parallel/parallel_api.py	(revision 8495)
+++ /trunk/anuga_core/source/anuga_parallel/parallel_api.py	(revision 8496)
@@ -36,8 +36,12 @@
 
 
-def distribute(domain, verbose=False):
+def distribute(domain, verbose=False, debug=False):
     """ Distribute the domain to all processes
     """
 
+
+    if debug:
+        verbose = True
+        
     barrier()
 
@@ -105,10 +109,22 @@
                 number_of_full_nodes, number_of_full_triangles,\
                 s2p_map, p2s_map, tri_map, node_map =\
-                distribute_mesh(domain, verbose=verbose)
-
-
+                distribute_mesh(domain, verbose=verbose, debug=debug)
+
+
+
+
+            
         # Extract l2g maps
         tri_l2g  = extract_l2g_map(tri_map)
         node_l2g = extract_l2g_map(node_map)
+
+        if debug:
+            print 'P%d' %myid
+            print 'tri_map ',tri_map
+            print 'node_map',node_map
+            print 'tri_l2g', tri_l2g
+            print 'node_l2g', node_l2g
+            print 's2p_map', s2p_map
+            print 'p2s_map', p2s_map
 
         # Send serial to parallel (s2p) and parallel to serial (p2s) triangle mapping to proc 1 .. numprocs
@@ -192,5 +208,9 @@
 
 
-def distribute_mesh(domain, verbose=False):
+def distribute_mesh(domain, verbose=False, debug=False):
+
+
+    if debug:
+        verbose = True
 
     numprocs = size()
@@ -220,4 +240,8 @@
                   %(N, M, p)
 
+    #if debug:
+    #    from pprint import pprint
+    #    pprint(submesh)
+
 
     # Send the mesh partition to the appropriate processor
@@ -270,5 +294,6 @@
 
 def extract_l2g_map(map):
-    # Extract l2g_map
+    # Extract l2g data  from corresponding map
+    # Maps
 
     import numpy as num
Index: /trunk/anuga_core/source/anuga_parallel/parallel_shallow_water.py
===================================================================
--- /trunk/anuga_core/source/anuga_parallel/parallel_shallow_water.py	(revision 8495)
+++ /trunk/anuga_core/source/anuga_parallel/parallel_shallow_water.py	(revision 8496)
@@ -79,4 +79,9 @@
         self.s2p_map = s2p_map
         self.p2s_map = p2s_map
+
+
+        self.s2p_map = None
+        self.p2s_map = None
+
         self.tri_l2g = tri_l2g
         self.node_l2g = node_l2g
Index: /trunk/anuga_core/source/anuga_parallel/run_parallel_sw_merimbula.py
===================================================================
--- /trunk/anuga_core/source/anuga_parallel/run_parallel_sw_merimbula.py	(revision 8495)
+++ /trunk/anuga_core/source/anuga_parallel/run_parallel_sw_merimbula.py	(revision 8496)
@@ -63,5 +63,5 @@
 
     def __call__(self, x, y):
-        return self.h*((x>self.x0)&(x<self.x1))
+        return self.h*((x>self.x0)&(x<self.x1))+1.0
 
 
Index: /trunk/anuga_core/source/anuga_parallel/run_parallel_sw_merimbula_profile.py
===================================================================
--- /trunk/anuga_core/source/anuga_parallel/run_parallel_sw_merimbula_profile.py	(revision 8495)
+++ /trunk/anuga_core/source/anuga_parallel/run_parallel_sw_merimbula_profile.py	(revision 8496)
@@ -63,5 +63,5 @@
 
     def __call__(self, x, y):
-        return self.h*((x>self.x0)&(x<self.x1))
+        return self.h*((x>self.x0)&(x<self.x1)) + 1.0
 
 #--------------------------------------------------------------------------